function create_login_button(url) {
    $("#p2Auth").attr("value", "Login");
    $("#p2Auth").jqxButton({ theme: 'darkblue', width: '100', height: '32'});
    $("#p2Auth").on('click', function () {
        $(window).attr('location', url);
    });
}

function create_logout_button(user) {
    $("#p2Auth").attr("value", "Logout");
    $( "#user" ).text( " Welcome back "+user+"! " );
    $("#p2Auth").jqxButton({ theme: 'orange', width: '100', height: '32'});
    $("#p2Auth").on('click', function () {
        $(window).attr('location', '/main/logout');
    });
}

function display_ack_window(title, msg) {
    $("#ack_window_title").text(title);
    $("#ack_window_msg").text(msg);
    $("#ack_window").jqxWindow({ 
        height: 150,
        width: 'auto', 
        autoOpen: false, 
        isModal: true, 
        okButton: $('#ack_button'), 
        initContent: function () {
            $("#ack_button").jqxButton({ width: 80, height: 30 });
            $('#ack_button').focus();
        }
    });
    $("#ack_window").jqxWindow('open');
    $("#ack_window").jqxWindow('focus');
}

function p2store_select(table, params, callback) {
    try {
        $.ajax({
            type: "POST",
            url: '/main/select/'+table,
            data: { 'params': JSON.stringify(params) },
            datatype: "json",
            success: callback,
            error: function(XMLHttpRequest, textStatus, errorThrown) { 
                display_ack_window("Select error", "Error selecting records from "+table);
            }
        });
    }
    catch (e) {
        display_ack_window("Error selecting table "+table, e)
    }
}

/* updates a record in the p2store table. The where dict needs to select a unique 
 * record. The fields dict defines the selected record fields to update, the
 * callback is called when a successfull call is made
 */
function p2store_update( table, where, fields, callback) {
    try {
        $.ajax({
            type: "PUT",
            url: "/main/update/" + table,
            data: { "params": JSON.stringify({
                where: where,
                fields: fields,
            })},
            datatype: "json",
            success: callback,
            error: function(XMLHttpRequest, textStatus, errorThrown) { 
                display_ack_window("Update error", "Error updating table "+table);
            }
        });
    }
    catch (e) {
        display_ack_window("Error updating table "+table, e)
    }
}

/* Inserts or updates a record in the p2store table. 
 * Conflicting_cols is the list of columns that has to be unique, otherwise
 * the already present record is updated.
 * The passed record has to contain the conflicting cols as well.
 * The callback is called in case of success, otherwise a msg is displayed.
 *
 */
function p2store_update_on_conflict( table, conflicting_cols, record, callback) {
    try {
        $.ajax({
            type: "POST",
            url: "/main/update_on_conflict/" + table,
            data: { "params": JSON.stringify({
                conflicting_cols: conflicting_cols,
                record: record
            })},
            datatype: "json",
            success: callback,
            error: function(XMLHttpRequest, textStatus, errorThrown) { 
                display_ack_window("Update error", "Error updating table "+table);
            }
        });
    }
    catch (e) {
        display_ack_window("Error updating table "+table, e)
    }
}
